/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
"use strict";
var page = require('webpage').create();
var system = require('system');
import {logger} from '../../util/util.js';

const LOGGER = logger(__filename);

var generate = function(reportHtml,reportPdf){
  if (!reportHtml){
    LOGGER.info('Usage report.html report.pdf');
    phantom.exit(1);
  }
  var reportPdf = reportPdf || reportHtml.split('.')[0] + '.pdf';
  
  var address = reportHtml;
  var output = reportPdf;
  // page.viewportSize = { width: 600, height: 600 };
  page.paperSize = {
      format: 'A4',
      margin: "0cm",
      footer: {
          height: "1cm",
          contents: phantom.callback(function(pageNum, numPages) {                
              return "<span style='float:right; color:blue'>" + pageNum + " / " + numPages + "</span>";
          })
      }
  };
  page.open(address, function (status) {
      if (status !== 'success') {
        //TODO set proper level & control log based on level
        LOGGER.info('Unable to load the address!',address);
      } else {                        
          window.setTimeout(function () {
              page.render(output);
              phantom.exit();
          }, 200);
      }
  });
}
generate(system.args[1],system.args[2]);
   
