/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
import path from 'path';
import * as util from './util.js';
import tablegenerator from '../table/header-details-footer-table-generator.js';
import chartgenerator from '../chart/chart-generator.js';
import htmlpdfgenerator from './html-n-pdf-generator-a4.js';
import {logger} from '../../util/util.js';

const LOGGER = logger(__filename);
const program = util.init();
const readJsonFromFile = util.readJsonFile;
const readCssFromFile = util.readCssFile;
const schemaFileName = 'template-v1.json';  // todo make it config driven
const datasetFileName = 'report-v1.json';  // todo make it config driven
const cssFileName = 'header-details-footer-table-a4.css';
const schema = readJsonFromFile(path.join(program.reportdir,schemaFileName));  
const dataset = readJsonFromFile(path.join(program.reportdir,datasetFileName));  
const style = readCssFromFile(path.join(program.reportdir,cssFileName));   

const t1 = new Date().getTime();
const widgetsByType = util.widgetsByType(schema);
const widgets = schema.template.widgets;
const widgetDataSet = dataset.report.widgets;

const onComplete = ()=>{
  const onReportEnd = ()=>{
    const t2 = new Date().getTime();
    LOGGER.info('::: TIME TO RENDER REPORT :::',(t2-t1)/1000,' seconds');
  }
  const completion = {onReportEnd};
  htmlpdfgenerator.generate(schema,tableWidgetHtml,chartWidgetHtml,program,completion);  
}
const callback = {onComplete};

const tableWidgetHtml = tablegenerator.generate('A4',schema,dataset,style,widgetsByType.headerDetailsFooter);
const chartWidgetHtml = chartgenerator.generate('A4',schema,dataset,widgetsByType.chart,callback);


