/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */

import puppeteer from 'puppeteer';
import os from 'os';
import * as util from '../util/util.js';
import path from 'path';

const LOGGER = util.logger(__filename);

const pdfgen = function(props){   
  let htmlLoc = props.htmlLoc ,pdfLoc = props.pdfLoc; 
  if (!htmlLoc){
    //TODO set proper level & control log based on level
    LOGGER.info('Usage report.html report.pdf');
    process.exit(1);
  }
  pdfLoc = pdfLoc || htmlLoc.split('.html')[0] + '.pdf';
  
  const address = 'file:///'+htmlLoc;
  
  LOGGER.info('address ',address);
  const output = pdfLoc;
  
  const pdf = async ()=> {
    const chromePath = util.program().chromeexecutablepath;
    let browser;
    if (chromePath) {
      browser = await puppeteer.launch({executablePath:chromePath,args: ['--no-sandbox', '--disable-setuid-sandbox']});	
    }
    else{
      browser = await puppeteer.launch({args: ['--no-sandbox', '--disable-setuid-sandbox']});
    }
    const page = await browser.newPage();   
    const pageDefaultNavigationTimeout = util.timeouts().pageDefaultNavigationTimeout || 120000;   
    LOGGER.info('page load timeout', pageDefaultNavigationTimeout);        
    await page.goto(address,{ timeout: pageDefaultNavigationTimeout });   
    // Get the "viewport" of the page, as reported by the page.
    // deviceScaleFactor: window.devicePixelRatio
    const dimensions = await page.evaluate(() => {
      return {
        width: document.documentElement.clientWidth,
        height: document.documentElement.clientHeight                
      };
    });  
    const width = dimensions.width;
    const height  = '8in';
	const printBackground  = true;
    await page.pdf({path: pdfLoc,width,height,printBackground});
    await browser.close();
  } 
  return pdf();
}
export {pdfgen};
// const html = 'file:///F:/home/govindan/report/report-Health%20Summary-1511259235766/report.html';
// const html = 'F:/home/govindan/report/report-Health Summary-1511259235766/report.html';
// const pdf = 'F:/home/govindan/report/1 2/report.pdf';
// const pdf = 'c:/report/report.pdf';
// const props = {htmlLoc:html};
// pdfgen(props);  