/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
import React from 'react';
import ReactDOMServer from 'react-dom/server';
import * as util from '../util/util.js';

class FilterPanel extends  React.Component {
  
  render(){ 
    const filters = this.props.filters || [];            
    const FilterList = (props) => {
      const Filter = (props) => {
        const FilterFragment = (props)=>{
          const headerHtml = (headerText,index)=> {
            if (headerText.constructor.name === "Array"){
              const subFilterHtml = (header,index)=>{
                const resolvedMessage=util.resolveMessage(header);
                return <span key={index} className="sub-filter">{resolvedMessage}</span>
              }
              const subFiltersHtml = headerText.map(subFilterHtml);
              return <span key={index} className="filter">{subFiltersHtml}</span>; 
            } 
            const resolvedMessage=util.resolveMessage(headerText);
            return <span key={index} className="filter">{resolvedMessage}</span>; 
          }
          const header = props.filterfragment.text || []; // string array 
          const titles = header.map(headerHtml);      
          return <div className={props.filterfragment.className}>{titles}</div>;  
        }
        const filterFragmentHtml = (filterFragement,index)=>{
            return <FilterFragment key={index} filterfragment={filterFragement}/>
        }
        const filterFragments = props.filter; // array of {header,className} object
        const filterFragmentsHtml = filterFragments.map(filterFragmentHtml);
        return <div className={props.className}>{filterFragmentsHtml}</div>
      }      
      const filterHtml = (filterObj,index)=>{
        return <Filter className="filter-row" key={index} filter = {filterObj.filter}/>
      }            
      const filterListHtml = props.filters.map(filterHtml);
      return <div>{filterListHtml}</div>;
    }
    const filtersElement = <div className="filter-panel">      
      <FilterList filters={filters}/>
    </div>;           
    return filtersElement;
  }
}

if (require.main === module){ // test the unit
  const schema = {"template":{"page":{ "headers": {"title":[
  {"header":["Report Title"],className:"report-title"},
  {"header":["Sub Title 1","Sub Title 2"],className:"report-scope"}
  ],"filters":[{"filter":[{"text":["Filter Name:Exchange Server Flows 1"],"className":"report-filter"},{"text":["Initiator:23c801","Initiator 2:23c801","Initiator 3:23c801","Initiator 4:23c801"],"className":"report-filter"},{"text":["Target:24c801",["Target 2:24c801","LUN:2"],"Target 3:24c801","Target 4:24c801"],"className":"report-filter"}]},{"filter":[{"text":["Filter Name:Exchange Server Flows 2"],"className":"report-filter"},{"text":["Initiator:23c801","Initiator 2:23c801","Initiator 3:23c801","Initiator 4:23c801"],"className":"report-filter"},{"text":["Target:24c801","Target 2:24c801","Target 3:24c801","Target 4:24c801"],"className":"report-filter"}]}]
  }}}};

 // const schema = {"template":{"page":{"headers":{"note":[{text:['Notes goes here'],className:'table-note'}]}}}}

  const filters= schema.template.page.headers.filters;
  
  const html = ReactDOMServer.renderToString(
          <FilterPanel filters={filters}/>);
          console.log('::: HTML :::',html);
}

export {FilterPanel}

