/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
import React from 'react';
import ReactDOMServer from 'react-dom/server';
import * as util from '../util/util.js';

const LOGGER = util.logger(__filename);

class FooterPanel extends  React.Component {
  
  render(){ 
    const footers = this.props.footers || {};    
    const Footer = (props) => {
      const makeFooterCol = (footerCol,index)=> {
        const text = footerCol.text || [];        
        const makeFooterColFragment = (makeFooterColFragment,index)=>{
          const resolvedMessage = util.resolveMessage(makeFooterColFragment);  
          return  <span key={index}>{resolvedMessage}</span>
        }
        const footerColElement = text.map(makeFooterColFragment);                
        return <span key={index} className={footerCol.className}>{footerColElement}</span>;
      }
      const footer = props.footer || [];
      const footerRow = footer.map(makeFooterCol)      
      return <div>{footerRow}</div>;
    }    
    const createFooter = (footer,index)=>{  
      LOGGER.info(':: footer ::',footer,footers[footer]);
      return <Footer key={index} footer={footers[footer]}/>
    }
    
    const footersElement = Object.keys(footers).map(createFooter);
    const footersContainer = <div className="footer-panel">
      {footersElement}
      {this.props.children}
    </div>;            
    return footersContainer;
  }
}

if (require.main === module){ // test the unit

  const footers= {
        "time":[{
          "text":["Generated on 8/9/2017, 10:30:15 AM by Fabric Insight Portal"],
          "className":"report-footer"
          }
        ]
      };
  
  const html = ReactDOMServer.renderToString(
          <FooterPanel footers={footers}/>);
          console.log('::: HTML :::',html);
}

export {FooterPanel}

