/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
import React from 'react';
import ReactDOM from 'react-dom';
import ReactDOMServer from 'react-dom/server';
import {HeaderDetailsFooter} from './header-details-footer.js';
import fs from 'fs';

const generate = (media,schema,dataset,style,headerDetailsFooterWidgets)=>{
  // it seems to be OK to store characters of 2^30 in a JS string
  // so NO need to flush to disk when the table generated has huge HTML tags     
  switch (media){
    default:
    case 'screen':
    case 'A4':{
      const t1 = new Date().getTime();
      const widgets = schema.template.widgets;
      const widgetDataSet = dataset.report.widgets;
      const widgetHtml = {};
      const tableGenerator = (widgetId)=>{
        const schema = widgets[widgetId];
        const data = widgetDataSet[widgetId];    
        if (data.constructor.name  === 'Array'){
          let tableHtmls = "";
          const tableBuilder = (tableData)=>{
            let tableHtml = "";
            const title = schema.view.headers.title;
            const titleObj = {"title":title};
             tableHtml = ReactDOMServer.renderToString(
            <HeaderDetailsFooter  params={titleObj} schema={schema.properties} data={tableData} />);       
            tableHtml = "<div class='table-container'>" 
            + tableHtml + "<style>" + style + "</style>" + "</div>";
            
            tableHtmls = tableHtmls + tableHtml;
          }
          data.forEach(tableBuilder);
          widgetHtml[widgetId] = tableHtmls.toString();
        } else if (data.constructor.name === 'Object'){
          const title = schema.view.headers.title;
          const titleObj = {"title":title};
          widgetHtml[widgetId] = ReactDOMServer.renderToString(
          <HeaderDetailsFooter  params={titleObj} schema={schema.properties} data={data} />);       
          widgetHtml[widgetId] = "<div class='table-container'>" 
          + widgetHtml[widgetId] + "<style>" + style + "</style>" + "</div>"
        }
        
      }
      Object.keys(headerDetailsFooterWidgets).forEach(tableGenerator);
      const t2 = new Date().getTime();
      return widgetHtml;
    }
  }  
}

const generator = {generate};
export default generator;
  

