/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
import React from 'react';
import {HeaderTable,DetailsTable,TitlePanelFactory} from './components.js';
class HeaderDetailsFooter extends  React.Component {
  render(){
    let header = [];
    let footer = [];
    let details = []; 
    const schema = this.props.schema;
    const data = this.props.data;
    const headerFilter = (prop) => {
      if (typeof schema[prop].view === 'undefined')
        return false;
      return schema[prop].view.in === "header";
    }
    const footerFilter = (prop) =>{
      if (typeof schema[prop].view === 'undefined')
        return false;
      return schema[prop].view.in === "footer";
    } 
    const detailsFilter = (prop) =>{
      if (typeof schema[prop].view === 'undefined')
        return false;
      return schema[prop].view.in === "details";
    } 
    debugger;
    header = Object.keys(schema).filter(headerFilter);
    footer = Object.keys(schema).filter(footerFilter);
    details = Object.keys(schema).filter(detailsFilter);
    const tDetail = (detail,index) => { 
      const detailsTableHeader = Object.keys(schema[detail].items.properties);
      const detailsTableData = data[detail];
      const totalRecordsCount = data.totalRecordsCount;      
      return <DetailsTable key={index} schema={schema[detail].items.properties}
        header={detailsTableHeader} detail={detailsTableData} totalRecords={totalRecordsCount}/>
    }      
    const title = this.props.params.title;
    const TitlePanelEnhanced = TitlePanelFactory(title);
    
    const tTitle = <TitlePanelEnhanced title={title}/>;
    const tDetails = details.map(tDetail);    
    const tHeader = <HeaderTable header={header} schema={schema} detail={data}/>;
    const tFooter = <HeaderTable header={footer} schema={schema} detail={data}/>;    
    
    return <section>{tTitle}{tHeader}{tDetails}{tFooter}</section>;
  }
}

export {HeaderDetailsFooter};