/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
import React from 'react';
class HeaderTable extends  React.Component {
  
  render(){
    debugger;
    const header = this.props.header;  
    const schema = this.props.schema;  
    const details = this.props.detail;  
    
    const tHeader = <HeaderRow header={header} schema={schema}/>;    
    const tDetail = (detail,index)=><DetailRow key={index}  header={header} schema={schema} detail={detail}/>;
    let detailsArray = [] ;
    if (details.constructor.name !== 'Array'){       
     detailsArray.push(details);
    } else {
      detailsArray = details;
    }
    const tDetails = detailsArray.map(tDetail);
    return <table>
      <thead>{tHeader}</thead>
      <tbody>{tDetails}</tbody>
    </table>;
  }
}

class HeaderRow extends  React.Component {
  render(){
    const row = this.props.header;
    const schema = this.props.schema;
    const tCol = (col,index)=> <HeadCol key={index} col={schema[col].view.displayName || col}/>;    
    const tRow = row.map(tCol);
    
    return <tr>{tRow}</tr>;
  }
}
class DetailRow extends  React.Component {
  render(){
    const header = this.props.header;
    const schema = this.props.schema;
    const detail = this.props.detail;    
    const tCol = (col,index)=> <Col key={index} col={detail[col]}/>;    
    const tRow = header.map(tCol);
    
    return <tr>{tRow}</tr>;
  }
}
class Col extends  React.Component {
  render(){
    const col = this.props.col;    
    const tCol = col;    
    return <td>{tCol}</td>;
  }
}
class HeadCol extends  React.Component {
  render(){
    const col = this.props.col;    
    const thCol = col;    
    return <th>{thCol}</th>;
  }
}

export {HeaderTable}

