/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
  /**
 * Author : gneelagi
 * Version : 1.0
 */
import React from 'react';
import ReactDOMServer from 'react-dom/server';
import * as util from '../util/util.js';

class NotesPanel extends  React.Component {
  
  render(){ 
    const headers = this.props.note || [];
    const note = headers[0] || [];
    
    // better validate this assumption in a validator or have a default headers  
    const Note = (props) => {
      const makeNote = (noteText,index)=> {
        // TODO we should not use globals, everything should be from props
        // that avoid un-necessary component bindings for resolving messages.
        const resolvedMessage=util.resolveMessage(noteText);
        return <span key={index}>{resolvedMessage}</span>;
      }
      const header = props.note.text || [];
      const notes = header.map(makeNote)      
      return <div className={props.note.className}>{notes}</div>;
    }    
    const noteElement = <div className="note-row">
      <Note note={note}/>                    
    </div>;
    if (note && note.length == 0){
      return null;
    }    
    return noteElement;
  }
}

if (require.main === module){ // test the unit
  const schema = {"template":{"page":{"headers":{"note":[{text:['Notes goes here'],className:'table-note'}]}}}}
  const headers= schema.template.page.headers;
  const note = headers.note || {};
  const html = ReactDOMServer.renderToString(
          <NotesPanel note={note}/>);
          console.log('::: HTML :::',html);
}

export {NotesPanel}

