/*-
 * UNPUBLISHED SOURCE CODE
 *
 * Copyright © 2017, Brocade Communications Systems, Incorporated.
 * ALL RIGHTS RESERVED.
 *
 * BROCADE HIGHLY CONFIDENTIAL TRADE SECRET INFORMATION
 *
 * Access or possession of this material grants you no right or license,
 * express, implied, statutory or otherwise, under any Brocade patent,
 * copyright, trade secret right or other intellectual property right.
 * Any such license must be contained in a written license agreement
 * signed by an authorized officer of Brocade.  Additionally, access or
 * possession of this material is limited to Brocade employees with a
 * need to know or named employees of Brocade vendors authorized by
 * Brocade in writing to access this material.
 *
 * Restricted Rights: Use, duplication, or disclosure by the U.S.
 * Government is subject to restrictions of FAR 52.227-19 and its
 * successors, or (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFAR 252.227-7013 and its successors.
 *
 * Brocade Communications Systems, Inc.,
 * 110 Holger Way, San Jose, CA 95134
 */
/**
* Author : gneelagi
* Version : 1.0
*/
import React from 'react';
import ReactDOMServer from 'react-dom/server';
import * as util from '../util/util.js';

class KeyValueList extends React.Component {

  render() {
    const keyValueList = this.props.keyValueList || [{ "key": "title", "value": "", "className": "key-value-pair" }];
    if (keyValueList.length == 0) {
      return <span />
    }
    const delimiter = this.props.delimiter || ":";
    const KeyValue = (props) => {
      if (props.Value === null || props.Value.trim() === "null") {          
        return null;
      }
      const className = props.className || "key-value-pair";
      return <div className={className}>
        <span className="key">{props.Key}{delimiter}</span><span className="value">{props.Value}</span>
      </div>
    }

    const keyValueListElement = keyValueList.map(
      (keyValue, index) => <KeyValue Key={keyValue.key} Value={keyValue.value} className={keyValue.className} key={index} />
    );

    return <div className="key-value-list"> {keyValueListElement}</div>;
  }
}

if (require.main === module) { // test the unit
  const kvList = [{ "key": "Network Scope", "value": "ALL FABRICS", "className": "keyvaluetest" }, { "key": "Time Scope", "value": "ALL FABRICS", "className": "keyvalue" }];
  const delimiter = "#";

  const html = ReactDOMServer.renderToString(
    <KeyValueList keyValueList={kvList} delimiter={delimiter} />);
    console.log('::: HTML :::', html);
}

export { KeyValueList }

